<template>
  <div>
    <div class="epub-container">
      <slot name="prev-btn" :goToPrevPage="goToPrevPage">
        <div id="prev" class="arrow" @click="goToPrevPage">‹</div>
      </slot>
      <slot name="book-content">
        <div :id="bookArea"></div>
      </slot>
      <slot name="next-btn" :goToNextPage="goToNextPage">
        <div id="next" class="arrow" @click="goToNextPage">›</div>
      </slot>
    </div>
    <slot
      name="progress-bar"
      :onChange="onChange"
      :onMousedown="onMousedown"
      :onMouseup="onMouseup"
    >
      <div class="epub-reading-progress-bar">
        <input
          size="3"
          type="range"
          max="100"
          min="0"
          step="1"
          @change="onChange($event.target.value)"
          :value="progress"
        > %
        <input
          type="text"
          @change="onChange($event.target.value)"
          @mousedown="onMousedown"
          @mouseup="onMouseup"
          :value="progress"
        >
      </div>
    </slot>
  </div>
</template>

<script>
import EventBus from "../../main";
import Ebook from 'epubjs'
import Epub from 'epubjs';
export default {
  name: "BookReader",
  props: {
    ebook: {
      required: true
    },
    fontSize: {
      type: Number,
      default: 100
    },
    themes: {
      type: Object,
      required: true
    },
    theme: {
      type: String,
      required: true
    },
    progress: {
      type: Number,
      required: true
    },
    bookArea: {
      type: String,
      default: "area"
    },
    contentBookModify: {
      type: Number,
      default: 0
    }
  },
  data() {
    return {
      book: null,
      rendition: null,
      section: null,
      toc: [],
      progressValue: 0,
      slide: null,
      mouseDown: false,
      cfi: null,
      width: 0,
      height:
        Math.max(document.documentElement.clientHeight || 0) -
        this.contentBookModify -
        300
    };
  },
  watch: {
    theme(val) {
      this.setTheme(val);
    },

    fontSize(val) {
      this.setFontSize(val);
    },

    progressValue(val) {
      this.$emit("update:progress", val);
    }
  },
  methods: {
    initReader() {
      this.rendition = this.book.renderTo(this.bookArea, {
        contained: true,
        height:
          Math.max(document.documentElement.clientHeight || 0) -
          this.contentBookModify -
          300,
        width:    Math.max(document.documentElement.clientWidth || 0) -200
      });
      this.registerThemes();
      this.setTheme(this.theme);
      this.rendition.display();
    },

    registerThemes() {
      this.rendition.themes.register(this.themes);
    },

    goToPrevPage() {
      this.rendition.prev();
    },

    goToNextPage() {
      this.rendition.next();
    },

    setTheme(theme) {
      this.rendition.themes.select(theme);
      document.body.style.background = this.themes[theme]["body"].background;
    },

    setFontSize(size) {
      this.rendition.themes.fontSize(size + "%");
    },

    goToExcerpt(cfi) {
      if (cfi.toLowerCase().indexOf("xhtml") > 0) {
        this.rendition.display(cfi);
      } else {
        this.rendition.display("epubcfi(" + cfi + ")");
        this.rendition.annotations.highlight("epubcfi(" + cfi + ")");
      }
    },

    showProgress() {
      this.book.ready
        .then(() => {
          let key = this.book.key() + "-locations";
          let stored = localStorage.getItem(key);
          if (stored) {
            return this.book.locations.load(stored);
          } else {
            return this.book.locations.generate(1600);
          }
        })
        .then(locations => {
          let cfi = this.book.locations.cfiFromPercentage(this.progress / 100);
          this.rendition.display(cfi).then(() => {
            let currentLocation = this.rendition.currentLocation();
            let currentPage = this.book.locations.percentageFromCfi(
              currentLocation.start.cfi
            );
            if (currentPage > 0) {
              this.progressValue = currentPage;
            }
          });

          this.rendition.on("relocated", location => {
            let percent = this.book.locations.percentageFromCfi(
              location.start.cfi
            );
            let percentage = Math.floor(percent * 100);
            this.progressValue = percentage;
          });
          localStorage.setItem(
            this.book.key() + "-locations",
            this.book.locations.save()
          );
        });
    },

    onChange(value) {
      let cfi = this.book.locations.cfiFromPercentage(value / 100);
      this.rendition.display(cfi);
    },

    onMousedown() {
      this.mouseDown = true;
    },

    onMouseup() {
      this.mouseDown = false;
    },

    updateScreenSizeInfo() {
      this.width = Math.max(document.documentElement.clientWidth || 0) -200

      this.height =
        Math.max(document.documentElement.clientHeight || 0) -
        this.contentBookModify -
        300;
    },

    resizeToScreenSize() {
      this.updateScreenSizeInfo();
      this.rendition.resize(this.width, this.height);
    },

    debounce(func, wait, immediate) {
      let timeout;
      return () => {
        let context = this;
        let args = arguments;
        let later = () => {
          timeout = null;
          if (!immediate) func.apply(context, args);
        };
        let callNow = immediate && !timeout;
        clearTimeout(timeout);
        timeout = setTimeout(later, wait);
        if (callNow) func.apply(context, args);
      };
    },

    keyListener(e) {
      if ((e.keyCode || e.which) === 37) {
        this.rendition.prev();
      }
      if ((e.keyCode || e.which) === 39) {
        this.rendition.next();
      }
    }
  },
  mounted() {
    this.book = new Epub(this.ebook,{replacements:'ArrayBuffer'});
    this.book.loaded.navigation.then(({ toc }) => {
      this.toc = toc;
      this.$emit("toc", this.toc);
      this.initReader();
      this.showProgress();
      this.rendition.on("click", () => {
        this.$emit("closeAppearanceMenu", false);
      });
    });

    this.$root.$on("showPage", cfi => {
      this.cfi = cfi;
      this.goToExcerpt(cfi);
    });
    this.$root.$on("clearHighlight", () => {
      this.rendition.annotations.remove("epubcfi(" + this.cfi + ")");
    });

    this.$nextTick(() => {
      window.addEventListener(
        "resize",
        this.debounce(() => {
          this.resizeToScreenSize();
        }, 250)
      );
    });

    this.updateScreenSizeInfo();

  },

  created() {

    window.addEventListener("keyup", this.keyListener);
  },

  beforeDestroy() {
    window.removeEventListener("keyup", this.keyListener);
  }

};
</script>
